ToDoApplication.AspNetMVC/Controllers/DueTodayController.cs
using Microsoft.AspNetCore.Mvc.ViewFeatures;
using Microsoft.AspNetCore.Mvc;
using System.Collections.Generic;
using Microsoft.AspNetCore.Mvc.ModelBinding;
using ToDoApplication.Domain.Repository;
using ToDoApplication.Domain.Entity;
using ToDoApplication.AspNetMVC.Models;
using System.Diagnostics;

namespace ToDoApplication.AspNetMVC.Controllers
{
    public class DueTodayController : Controller
    {
        private readonly IItemRepository _repository;

        public DueTodayController(IItemRepository rep)
        {
            _repository = rep;
        }

        public IActionResult Index()
        {
            var viewModel = new ItemViewModel
            {
                Items = (List<Item>)_repository.GetItemsDueToday()
            };

            return View(viewModel);
        }


    }


}

ToDoApplication.AspNetMVC/Controllers/HiddenController.cs
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Logging;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using ToDoApplication.AspNetMVC.Models;
using ToDoApplication.Domain.Entity;
using ToDoApplication.Domain.Repository;

namespace ToDoApplication.AspNetMVC.Controllers
{
    public class HiddenController : Controller
    {
        private readonly IToDoRepository _repository;
        public HiddenController(IToDoRepository repository)
        {
            _repository = repository;
        }

        public IActionResult Index()
        {
            var viewModel = new TodoViewModel
            {
                ToDos = (List<ToDo>)_repository.Hidden(),
            };

            return View(viewModel);
        }

        public IActionResult Unhide(int id)
        {
            _repository.Unhide(id);
            return RedirectToAction("Index");
        }


    }
}

ToDoApplication.AspNetMVC/Controllers/HomeController.cs
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Logging;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using ToDoApplication.AspNetMVC.Models;
using ToDoApplication.Domain.Entity;
using ToDoApplication.Domain.Repository;

namespace ToDoApplication.AspNetMVC.Controllers
{
    public class HomeController : Controller
    {
        private readonly IToDoRepository _repository;
        private readonly IItemRepository _itemRepository;
        private readonly IFieldRepository _fieldRepository;

        public HomeController(IToDoRepository repository, IItemRepository itemRepository, IFieldRepository fieldRepository)
        {
            _repository = repository;
            _itemRepository = itemRepository;
            _fieldRepository = fieldRepository;
        }

        public IActionResult Index()
        {
            var viewModel = new TodoViewModel
            {
                ToDos = (List<ToDo>)_repository.GetAll(),
                ItemCount = _itemRepository.CountItemDueToday(),
            };

            return View(viewModel);
        }

        public JsonResult PopulateForm(int id)
        {
            return Json(_repository.Get(id));
        }

        internal TodoViewModel GetAll()
        {
            List<ToDo> list = (List<ToDo>)_repository.GetAll();

            return new TodoViewModel
            {
                ToDos = list
            };
        }

        public IActionResult Create(ToDo toDo)
        {
            _repository.Create(toDo);
            return RedirectToAction("Index");
        }

        public IActionResult Delete(int id)
        {
            _repository.Delete(id);
            return RedirectToAction("Index");
        }

        public IActionResult Hide(int id)
        {
            _repository.Hide(id);
            return RedirectToAction("Index");
        }

        public IActionResult Update(ToDo toDo)
        {
            _repository.Update(toDo);
            return RedirectToAction("Index");
        }

        public JsonResult Copy(int toDoId)
        {
            int[] ints = _repository.Copy(toDoId);
            int[] ints1 = _itemRepository.Copy(ints[0], ints[1]);
            int[] ints2 = _fieldRepository.Copy(ints1[0], ints1[1]);
            return Json(ints2);
        }


        [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
        public IActionResult Error()
        {
            return View(new ErrorViewModel { RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier });
        }
    }
}

ToDoApplication.AspNetMVC/Controllers/ItemController.cs
using Microsoft.AspNetCore.Mvc;
using System.Collections.Generic;
using System;
using System.Linq;
using ToDoApplication.Domain.Repository;
using ToDoApplication.AspNetMVC.Models;
using ToDoApplication.Domain.Entity;
using System.Diagnostics;

namespace ToDoApplication.AspNetMVC.Controllers
{
    public class ItemController : Controller
    {

        private readonly IItemRepository _repository;

        public ItemController(IItemRepository rep)
        {
            _repository = rep;
        }

        public IActionResult Index(int toDoId)
        {
            var viewModel = new ItemViewModel
            {
                Items = (List<Item>)_repository.GetItemsByToDoId(toDoId),
                ToDoId = toDoId
            };

            return View(viewModel);
        }


        public JsonResult Get(int toDoId)
        {
            var items = _repository.GetItemsByToDoId(toDoId);

            return Json(items);
        }

        public IActionResult Create(Item item)
        {
            _repository.Create(item);

            return RedirectToAction("Index", new { toDoId = item.ToDoId });
        }

        public JsonResult PopulateForm(int id)
        {
            var item = _repository.Get(id);

            return Json(item);
        }
        public IActionResult Delete(int id)
        {
            _repository.Delete(id);

            return RedirectToAction("Index");
        }
        public IActionResult Update(Item item)
        {
            _repository.Update(item);

            return RedirectToAction("Index", new { toDoId = item.ToDoId });
        }

    }
}

ToDoApplication.AspNetMVC/Views/Home/Form.cshtml
@model TodoViewModel

<form asp-action="Create" id="form-action" method="post" class="form-horizontal" role="form">
    <div asp-validation-summary="All" class="text-danger"></div>

    <div class="row justify-content-center">
          <div class="col-xl-8 col-lg-8 col-md-8 col-sm-10">
            <label asp-for="ToDo.Name" class="form-label"></label>
            <input asp-for="ToDo.Id" type="hidden" class="form-control" />
            <input asp-for="ToDo.Name" class="form-control" />
            <span asp-validation-for="ToDo.Name" class="text-danger"></span>
          </div>
    </div>
    <div class="row justify-content-center">
        <div class="col-xl-8 col-lg-8 col-md-8 col-sm-10 mt-3 mb-5">
            <input type="submit" id="form-button" class="btn btn-outline-secondary" value="Add ToDo" />
        </div>
    </div>

</form>

ToDoApplication.AspNetMVC/Views/Home/Index.cshtml
<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css" />
@model TodoViewModel

<div class="row justify-content-center">
    <div class="col-xl-8 col-lg-8 col-md-8 col-sm-10 d-flex justify-content-between mt-2">
        <div style="text-align: left;">
            <h1>Hello</h1>
            <h6>Today you have @Model.ItemCount tasks</h6>
            <form method="get" action="@Url.Action("Index", "DueToday")">
                <input type="submit" class="btn btn-outline-secondary" value="Today" />
            </form>
            <form method="get" action="@Url.Action("Index", "Hidden")">
                <input type="submit" class="btn btn-outline-secondary mt-2" value="Hidden" />
            </form>

        </div>
        <i class="fas fa-user fa-7x"></i>
    </div>
</div>
<div class="row justify-content-center">
    <div id="form1-container" class="col-12">
        <partial name="Form" />
    </div>
</div>

<div class="row justify-content-center">
    <div class="col-xl-8 col-lg-8 col-md-8 col-sm-10">
        <table class="table">
            <thead>
                <tr class="table-secondary">
                    <th scope="col">Name</th>
                    <th scope="col"></th>
                </tr>
            </thead>
            <tbody>
                @foreach (var t in Model.ToDos)
                {
                    <tr>
                        <td class="todos-column">@t.Name</td>
                        <td class="buttons-column">
                            <div class="d-flex">
                                <input type="submit" class="btn btn-outline-secondary" value="Delete" onClick="deleteToDo(@t.Id)" />
                                <input type="submit" class="btn btn-outline-secondary" value="Update" onClick="populateFormToDo(@t.Id)" />
                                <input type="submit" class="btn btn-outline-secondary" value="Hide" onClick="hideToDo(@t.Id)" />
                                <form method="get" action="@Url.Action("Index", "Item")">
                                    <input type="hidden" name="toDoId" value="@t.Id" />
                                    <input type="submit" class="btn btn-outline-secondary" value="View" />
                                </form>
                                <input type="submit" class="btn btn-outline-secondary" value="Copy" onClick="copyToDo(@t.Id)" />
                            </div>
                        </td>
                    </tr>
                }
            </tbody>
        </table>
    </div>
</div>